<?php
// developed by sjlu
// this is for mock purposes only

// the objective of this is to create a JSON array of
// usable mobile web shortcuts that are stored in a database

// for mock reasons, we will just create our own array
// later this should be from a database

$basedir = dirname(__FILE__);

include_once($basedir . '/include/config.php');

isset($GLOBALS['CONFIG']) or die("FATAL: " . __FILE__ . ":" . __LINE__. ": config parsing failed\n"); 

function generate_shortcut($handle, $title, $url, $canDelete, $dashFirst, $dashSecond, $fontSize=null)
{
   ($handle && $title && $url && $canDelete && $dashSecond) or die("FATAL: " . __FILE__ . ":" . __LINE__ . ": shortcut arguments not present");
   $s = compact("handle", "title", "url", "canDelete", "dashFirst", "dashSecond", "fontSize");

   return $s;
}

function save_data($json)
{
   $file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/0.0/shortcuts.txt', 'w');
   fwrite($file, $json);
   fclose($file);

   chmod($GLOBALS['CONFIG']['temp_dir'] . '/0.0/shortcuts.txt', 0644);
   rename($GLOBALS['CONFIG']['temp_dir'] . '/0.0/shortcuts.txt',$GLOBALS['CONFIG']['web_dir'] . '/0.0/shortcuts.txt');
}

$a = array();

# If a shortcut only has one line caption, use dashSecond only. So says rfranknj; blame him.
$a[] = generate_shortcut('sakai', 'Sakai', 'https://sakai.rutgers.edu/mobile', 'true', '', 'Sakai');
$a[] = generate_shortcut('stud_life', 'Student Life', 'http://getinvolved.rutgers.edu/m/', 'true', '', 'Student Life');
$a[] = generate_shortcut('campus_status', 'Emergency Notices', 'http://halflife.rutgers.edu/ec/notices.php', 'true', 'Emergency', 'Notices', 36);
$a[] = generate_shortcut('myrutgers', 'myRutgers', 'https://my.rutgers.edu/', 'true', '', 'myRutgers');

// FIXME: what if the handle is duplicate? we should error out. eh, database will fix this in the CREATE TABLE, nevermind for now
// FIXME: what if json_encode fails? Eh, Nagios check should come up, I hope.

save_data(json_encode($a));
