<?php

$_GET['route'] = $argv[1];

$basedir=dirname(__FILE__);

include_once($basedir . '/../include/config.php');
include_once($basedir . '/../include/xml2array.php');

isset($GLOBALS['CONFIG']) or die("FATAL: " . __FILE__ . ":" . __LINE__. ": config parsing failed\n");

//$pid = pcntl_fork();
$nextbus_url = 'http://webservices.nextbus.com/service/publicXMLFeed';
$agency = 'rutgers';

$vehicle_list = file_get_contents($nextbus_url . '?a=' . $agency . '&command=vehicleLocations&r=' . $_GET['route'] . '&t=0');
if ($vehicle_list === false) die();
$vehicle_list = xml2array($vehicle_list);
$vehicle_list = $vehicle_list['body'];

$predictions = array();

$predictions['running'] = true;
if (!isset($vehicle_list['vehicle']))
{
   $predictions['running'] = false;
}

if ($predictions['running'])
{
   $predictions['running'] = true;
   $route_stops = file_get_contents($nextbus_url . '?a=' . $agency . '&command=routeConfig&r=' . $_GET['route']);
   if ($route_stops === false) die();
   $route_stops = xml2array($route_stops);   
   
   $route_stops = $route_stops['body'];
   for ($i = 0; $i < count($route_stops['route']['stop']); $i++)
   {
      if (!isset($route_stops['route']['stop'][$i]['attr']['stopId']))
         continue;

      $route_stop_predic_list = file_get_contents ($nextbus_url . '?a=' . $agency . '&command=predictions&r=' . $_GET['route'] . '&stopId=' . $route_stops['route']['stop'][$i]['attr']['stopId']);
      if ($route_stop_predic_list === false) die();
      $route_stop_predic_list = xml2array($route_stop_predic_list);
      $route_stop_predic_list = $route_stop_predic_list['body']['predictions'];


      //if (!isset($route_stop_predic_list['body'])) echo $route_stop['route']['stop'][$i]['attr']['stopId'];
      if (isset($route_stop_predic_list[0]))
      {
         for ($k = 0; $k < count($route_stop_predic_list); $k++)
         {
            if ($route_stops['route']['stop'][$i]['attr']['tag'] == $route_stop_predic_list[$k]['attr']['stopTag'])
            {
               $route_stop_predic_list = $route_stop_predic_list[$k];
               break;
            }
         }
      }

      if (!isset($route_stop_predic_list['direction']))
         continue;
      
      $route_stop_predic_list = $route_stop_predic_list['direction']['prediction'];
      
      if (count($route_stop_predic_list) == 0)
      {
         $predictions['times'][$i] = null;
      }      

      if (count($route_stop_predic_list) == 1)
      {
         $predictions['times'][$i][0] = $route_stop_predic_list['attr']['minutes'];
      }
      else
      {
         for ($j = 0; $j < count($route_stop_predic_list); $j++)
            $predictions['times'][$i][$j] = $route_stop_predic_list[$j]['attr']['minutes'];
      }
   }
   
}

$json = json_encode($predictions);

$file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/0.0/nextbus/'.$_GET['route'].'.txt', 'w');
fwrite($file, $json);
fclose($file);
?>
