<?php

$_GET['stop'] = $argv[1];

$basedir=dirname(__FILE__);

include_once($basedir . '/../include/config.php');
include_once($basedir . '/../include/xml2array.php');

isset($GLOBALS['CONFIG']) or die("FATAL: " . __FILE__ . ":" . __LINE__. ": config parsing failed\n");

$nextbus_url = 'http://webservices.nextbus.com/service/publicXMLFeed';
$agency = 'rutgers';

$stop_data = file_get_contents($nextbus_url . '?a=' . $agency . '&command=predictions&stopId=' . $_GET['stop']);
if ($stop_data === false) die();
$stop_data = xml2array($stop_data);

$output = array();

$output['running'] = true;

$not_running_count = 0;
if (!isset($stop_data['body']['predictions']) || $stop_data['body']['predictions'] == null || $stop_data['body'] == null)
{
   $output['running'] = false;
}
else
{
   foreach ($stop_data['body']['predictions'] as $check_stop)
   {
      if (isset($check_stop['attr']['dirTitleBecauseNoPredictions']))
         $not_running_count++;
   }

   if ($not_running_count == count($stop_data['body']['predictions']))
      $output['running'] = false;
}

if ($output['running'])
{
   if(!isset($stop_data['body']['predictions'][0]))
   {
      $temp = $stop_data['body']['predictions'];
      $stop_data['body']['predictions'] = null;
      $stop_data['body']['predictions'][0] = $temp;
   }

   $output['stop_name'] = $stop_data['body']['predictions'][0]['attr']['stopTitle'];

   $i = 0;
   foreach ($stop_data['body']['predictions'] as $line_data)
//   for ($i = 0; $i < count($stop_data['body']['predictions']); $i++)
   {
      $output['lines'][$i]['route_name'] = $line_data['attr']['routeTitle'];

      if (isset($line_data['attr']['dirTitleBecauseNoPredictions'])
         || count($line_data['direction']['prediction']) == 0)
      {
         $output['lines'][$i]['predictions'] = null;
      } 
      else
      {
         $output['lines'][$i]['direction'] = $line_data['direction']['attr']['title'];
      
         if (!isset($line_data['direction']['prediction'][0]))
         {
            $temp = $line_data['direction']['prediction'];
            $line_data['direction']['prediction'] = null;
            $line_data['direction']['prediction'][0] = $temp;
         }

         for($j = 0; $j < count($line_data['direction']['prediction']); $j++)
            $output['lines'][$i]['predictions'][$j] = $line_data['direction']['prediction'][$j]['attr']['minutes'];    
      }

   $i++;
   
   }
}

$file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/0.0/nextbus/' . $_GET['stop'] . '.txt', 'w');
fwrite($file, json_encode($output));
fclose($file);
?>
